package eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.fightDetector;

import eu.mhsl.craftattack.spawn.core.appliance.Appliance;
import eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.teams.Teams;
import eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.teams.VaroTeam;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.jetbrains.annotations.NotNull;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class FightDetector extends Appliance {
    public static final Long FIGHT_TIMEOUT = 60 * 1000L;
    public final Map<VaroTeam, Long> fights = new HashMap<>();

    public boolean isInFight(VaroTeam team) {
        Long lastFightTime = this.fights.get(team);
        if(lastFightTime == null) return false;
        return (System.currentTimeMillis() - lastFightTime <= FIGHT_TIMEOUT);
    }

    public void setInFight(Player player) {
        VaroTeam team = this.queryAppliance(Teams.class).getTeamFromPlayer(player.getUniqueId());
        this.fights.put(team, System.currentTimeMillis());
    }

    @Override
    protected @NotNull List<Listener> listeners() {
        return List.of(
            new FightOnDistanceListener(),
            new FightOnInteractionListener()
        );
    }
}
